VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picMask 
      Height          =   615
      Left            =   3360
      ScaleHeight     =   555
      ScaleWidth      =   555
      TabIndex        =   1
      Top             =   480
      Visible         =   0   'False
      Width           =   615
   End
   Begin VB.PictureBox picHidden 
      Height          =   615
      Left            =   2400
      ScaleHeight     =   555
      ScaleWidth      =   555
      TabIndex        =   0
      Top             =   480
      Visible         =   0   'False
      Width           =   615
   End
   Begin VB.Timer tmrDrawSelection 
      Enabled         =   0   'False
      Interval        =   250
      Left            =   1800
      Top             =   1320
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' True when we are drawing.
Private m_Drawing As Boolean

Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Declare Function Polyline Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long

' The point information.
Private m_NumPoints As Long
Private m_Points() As POINTAPI

' True when the polygon is inverted.
Private m_Inverted As Boolean
' Copy the selected region to picHidden.
Private Sub CopySelectedRegion(Optional ByVal do_cut As Boolean = False)
    ' Remove the previous selction boundary.
    RemoveBoundary

    ' Erase the selected area in the mask.
    picMask.BackColor = vbBlack
    picMask.Cls
    picMask.ForeColor = vbWhite
    picMask.FillColor = vbWhite
    picMask.FillStyle = vbFSSolid
    Polygon picMask.hdc, m_Points(1), m_NumPoints
    picMask.Picture = picMask.Image

    ' Copy the full image onto picHidden.
    picHidden.PaintPicture Me.Picture, 0, 0

    ' Knock out the parts outside of the polygon.
    picHidden.PaintPicture picMask.Picture, 0, 0, Opcode:=vbSrcAnd

    ' Invert the black outlying area.
    picHidden.PaintPicture picMask.Picture, 0, 0, Opcode:=vbMergePaint
    picHidden.Picture = picHidden.Image

    ' Copy the result to the clipboard.
    Clipboard.Clear
    Clipboard.SetData picHidden.Picture

    ' If we should cut the area out of the original, do so.
    If do_cut Then
        Me.PaintPicture picMask.Picture, 0, 0, Opcode:=vbSrcPaint
    End If

    ' Redraw the closed curve, dotted.
    Polyline hdc, m_Points(1), m_NumPoints
    Refresh

    ' Restart the redraw timer.
    m_Inverted = False
    tmrDrawSelection.Enabled = True
End Sub
' Remove the selection boundary.
Private Sub RemoveBoundary()
    ' Erase the previously selected area.
    tmrDrawSelection.Enabled = False
    DrawMode = vbInvert
    If m_NumPoints > 0 Then
        If m_Inverted Then
            ' The previous polygon is inverted.
            ' Draw with DrawStyle = vbSolid to
            ' put it back to normal.
            DrawStyle = vbSolid
            Polyline hdc, m_Points(1), m_NumPoints
            m_Inverted = False
        End If

        ' Now invert with DrawStyle = vbDot to
        ' erase the polygon.
        DrawStyle = vbDot
        Polyline hdc, m_Points(1), m_NumPoints
    Else
        DrawStyle = vbDot
    End If
End Sub
Private Sub Form_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case 3  ' Ctrl-C
            CopySelectedRegion
        Case 24 ' Ctrl-X
            CopySelectedRegion True
    End Select
End Sub

Private Sub Form_Load()
Dim r As Integer
Dim c As Integer

    AutoRedraw = True
    ScaleMode = vbPixels
    ForeColor = vbRed

    ' Draw some boxes for a background.
    For r = 0 To ScaleHeight Step 20
        For c = 0 To ScaleWidth Step 20
            If (r \ 20 + c \ 20) Mod 2 = 1 Then
                Line (c, r)-Step(20, 20), , BF
            End If
        Next c
    Next r
    Me.Picture = Me.Image

    ' Prepare picHidden.
    picHidden.BorderStyle = vbBSNone
    picHidden.AutoRedraw = True
    picHidden.ScaleMode = vbPixels
    picHidden.Width = Me.ScaleWidth
    picHidden.Height = Me.ScaleHeight

    ' Prepare picMask.
    picMask.BorderStyle = vbBSNone
    picMask.AutoRedraw = True
    picMask.ScaleMode = vbPixels
    picMask.Width = Me.ScaleWidth
    picMask.Height = Me.ScaleHeight
End Sub

' Start drawing.
Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Drawing = True

    ' Remove the previous selction boundary.
    RemoveBoundary

    ' Save the initial point.
    m_NumPoints = 1
    ReDim m_Points(1 To m_NumPoints)
    With m_Points(m_NumPoints)
        .X = X
        .Y = Y
    End With

    ' Draw the polygon.
    Polyline hdc, m_Points(1), m_NumPoints
    Refresh
End Sub
' Continue drawing.
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Do nothing if we're not drawing.
    If Not m_Drawing Then Exit Sub

    ' Do nothing if the point hasn't changed.
    With m_Points(m_NumPoints)
        If (.X = X) And (.Y = Y) Then Exit Sub
    End With

    ' Erase the old curve.
    Polyline hdc, m_Points(1), m_NumPoints

    ' Save the new point.
    m_NumPoints = m_NumPoints + 1
    ReDim Preserve m_Points(1 To m_NumPoints)
    With m_Points(m_NumPoints)
        .X = X
        .Y = Y
        If .X < 0 Then .X = 0
        If .X >= ScaleWidth Then .X = ScaleWidth - 1
        If .Y < 0 Then .Y = 0
        If .Y >= ScaleHeight Then .Y = ScaleHeight - 1
    End With

    ' Draw the new curve.
    Polyline hdc, m_Points(1), m_NumPoints
    Refresh
End Sub
' Stop drawing.
Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    ' Do nothing if we're not drawing.
    If Not m_Drawing Then Exit Sub
    m_Drawing = False

    ' Erase the old curve.
    Polyline hdc, m_Points(1), m_NumPoints

    ' Close the curve.
    m_NumPoints = m_NumPoints + 1
    ReDim Preserve m_Points(1 To m_NumPoints)
    m_Points(m_NumPoints).X = m_Points(1).X
    m_Points(m_NumPoints).Y = m_Points(1).Y

    ' Draw the closed curve, dotted.
    Polyline hdc, m_Points(1), m_NumPoints
    Refresh

    ' Start the redraw timer.
    tmrDrawSelection.Enabled = True
    m_Inverted = False
End Sub

Private Sub tmrDrawSelection_Timer()
    ' Invert the selected area boundary.
    DrawMode = vbInvert
    DrawStyle = vbSolid
    Polyline hdc, m_Points(1), m_NumPoints
    Refresh
    DrawMode = vbCopyPen

    ' Remember whether the polygon is inverted or not.
    m_Inverted = Not m_Inverted
End Sub


